#!/usr/bin/env node
import { B as l, e as f } from "./app-automate-pda-fFRm.js";
import { B as w, e as h, w as p } from "./index.node-YPmUVZIZ.js";
import { readFile as E } from "node:fs/promises";
import { createRequire as T } from "node:module";
import { homedir as O, tmpdir as b } from "node:os";
import { join as y } from "node:path";
const $ = T(import.meta.url);
var I = /* @__PURE__ */ ((t) => (t.start = "start", t.stop = "stop", t.list = "list", t))(I || {});
async function B(t, i, e = globalThis.console) {
  const { localIdentifiers: r = [], ...n } = await u(
    i
  ), s = new w.LocalTestingBinary({
    ...t
  }), a = s.localIdentifier;
  let c;
  try {
    c = await s.start();
  } catch (o) {
    if (o instanceof l && o.code === "ETIMEDOUT")
      e.error(
        `${a}: Failed to complete command within ${s.commandTimeoutMs}ms timeout`
      );
    else if (o instanceof Error)
      e.error(`${a}: ${o.message}`);
    else
      throw o;
  }
  c && (r.push(a), await m(i, r, n), e.info(`${a}: ${c}`));
}
async function d(t, i, e = globalThis.console) {
  const r = new w.LocalTestingBinary({
    ...i,
    localIdentifier: t
  });
  let n;
  try {
    n = await r.stop(), e.info(`${t}: ${n}`);
  } catch (s) {
    s instanceof Error ? (s.message.match(/process instance not found/i) && (n = s.message), e.error(`${t}: ${s.message}`)) : e.error(`${t}: Failed to stop instance`);
  }
  return n;
}
async function S(t, i, e = globalThis.console) {
  var a, c;
  const { localIdentifiers: r = [], ...n } = await u(
    i
  ), s = (c = (a = t.localIdentifier) == null ? void 0 : a.trim) == null ? void 0 : c.call(a);
  if (s && r.includes(s))
    await d(s, t, e) && (r.splice(
      r.indexOf(s),
      1
    ), await m(i, r, n));
  else
    for (; r.length; ) {
      const o = r.shift();
      if (!o)
        break;
      await d(o, t, e) && await m(i, r, n);
    }
}
async function R(t, i = globalThis.console) {
  const { localIdentifiers: e = [] } = await u(t);
  for (const r of e)
    i.info(r);
}
function v() {
  return y(O() ?? b(), ".browserstack");
}
async function C(t = f.BROWSERSTACK_LOCAL_BINARY_HOME ?? f.BROWSERSTACK_LOCAL_BINARY_PATH) {
  const i = t ?? v();
  if (typeof i != "string" || !i.trim().length)
    throw new l("Missing binHome");
  return await h(i.trim());
}
function L(t) {
  const i = t ?? f.BROWSERSTACK_KEY;
  if (typeof i != "string" || !i.trim().length)
    throw new l("Missing key");
  return i.trim();
}
function _(t, i = Object.values(I)) {
  var r, n, s;
  const e = (s = (n = (r = t == null ? void 0 : t.toLowerCase) == null ? void 0 : r.call(t)) == null ? void 0 : n.trim) == null ? void 0 : s.call(n);
  if (e && i.includes(e))
    return e;
  throw new l(`Invalid action: ${e}`);
}
function g() {
  var t, i;
  return (i = (t = f.BROWSERSTACK_LOCAL_ID ?? f.BROWSERSTACK_LOCAL_IDENTIFIER) == null ? void 0 : t.trim) == null ? void 0 : i.call(t);
}
async function u(t, i = "utf-8") {
  try {
    const e = await E(t, i).then(
      (r) => r.trim()
    );
    if (e.length) {
      const r = JSON.parse(e), n = [];
      if (r && typeof r == "object")
        return "localIdentifiers" in r && Array.isArray(r.localIdentifiers) && n.push(
          ...r.localIdentifiers.filter((s) => typeof s == "string").map((s) => s.trim()).filter((s) => s.length)
        ), { localIdentifiers: n, ...r };
    }
    throw new l(`Invalid status file format: ${t}`);
  } catch (e) {
    if (e instanceof l)
      throw e;
    if (e instanceof Error && "code" in e && e.code === "ENOENT") {
      const r = { localIdentifiers: [] };
      return await m(
        t,
        r.localIdentifiers,
        {},
        i
      ), r;
    }
    throw new l(`Invalid status file: ${t}`);
  }
}
async function m(t, i, e = {}, r = "utf-8") {
  await p(
    t,
    JSON.stringify(
      {
        ...e,
        localIdentifiers: Array.from(new Set(i))
      },
      null,
      2
    ),
    { encoding: r }
  );
}
async function k(t = process.argv.slice(2), i = globalThis.console) {
  try {
    const e = t.map((o) => o.trim()), r = _(e[0]), n = g() ?? e[1], s = L(e[2]), a = await C(), c = y(a, "status.json");
    switch (r) {
      case "start": {
        await B({ key: s, binHome: a, localIdentifier: n }, c, i);
        break;
      }
      case "stop": {
        await S({ key: s, binHome: a, localIdentifier: n }, c, i);
        break;
      }
      case "list": {
        await R(c, i);
        break;
      }
      default:
        throw new l(
          `Invalid action: ${r} (valid actions: start, stop, list)`
        );
    }
  } catch (e) {
    e instanceof Error ? i.error(e.message) : i.error(`An unexpected error occurred: ${e}`), process.exit(1);
  }
}
$.main === module && k();
export {
  k as main
};
